;;; xml-utils.el --- Utilities for XML processing

;; Copyright (C) 2002 by Free Software Foundation, Inc.

;; Author: Alexander Mikhailian <mikhailian@altern.org>
;; Keywords: languages, tools

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;;; Test

;; <XML ATTR="TEXT">  </XML>

;;; Code:

(defun downcase-sgml-buffer()
  (interactive)
  "downcase all html tags in the current buffer"
  (setq debug-on-error t)
  (save-excursion
    (goto-char (point-min))
    (while (re-search-forward "\\(< */?\\)\\([^>]+\\)\\(>\\)" nil t)
      (downcase-sgml-tag (match-beginning 2) (match-end 2))))
  ;;(message "%d %d" (match-beginning 2) (match-end 2))))
  nil)

(defun downcase-sgml-tag(start end)
  (save-excursion
    (save-restriction
      (message "tag: %d %d" (match-beginning 2) (match-end 2))
      (narrow-to-region start end)
      (goto-char start)
      (if (re-search-forward "^[A-Z:]+" nil t)
          (downcase-region (match-beginning 0) (match-end 0)))
      (downcase-sgml-att (match-end 0) end)))
  nil)

(defun downcase-sgml-att(start end)
  (save-excursion
    (save-restriction
      (narrow-to-region start end)
      (goto-char start)
      (while (re-search-forward " [A-Z]+=" nil t)
        (downcase-region (match-beginning 0) (match-end 0)))))
  nil)

;;; xml-utils.el ends here
